"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var ts_selection_set_to_object_1 = require("./ts-selection-set-to-object");
var graphql_codegen_typescript_1 = require("graphql-codegen-typescript");
var TypeScriptDocumentsVisitor = /** @class */ (function (_super) {
    __extends(TypeScriptDocumentsVisitor, _super);
    function TypeScriptDocumentsVisitor(schema, config) {
        var _this = _super.call(this, config, {
            avoidOptionals: config.avoidOptionals || false,
            immutableTypes: config.immutableTypes || false
        }, schema) || this;
        _this.setSelectionSetHandler(new ts_selection_set_to_object_1.TypeScriptSelectionSetToObject(_this.scalars, _this.schema, _this.convertName, _this.config.addTypename, _this.config.immutableTypes));
        _this.setVariablesTransformer(new graphql_codegen_typescript_1.TypeScriptOperationVariablesToObject(_this.scalars, _this.convertName, _this.config.avoidOptionals, _this.config.immutableTypes));
        return _this;
    }
    return TypeScriptDocumentsVisitor;
}(graphql_codegen_visitor_plugin_common_1.BaseDocumentsVisitor));
exports.TypeScriptDocumentsVisitor = TypeScriptDocumentsVisitor;
//# sourceMappingURL=visitor.js.map